﻿using MyMod.Hediff;
using RimWorld;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Verse;

namespace MyMod.Events
{
    public class GameCondition_TestCondition : GameCondition
    {
        public override void Init()
        {
            base.Init();

            Log.Message($"{def.defName} executed");
        }

        public override void GameConditionTick()
        {
            base.GameConditionTick();

            if(Find.TickManager.TicksGame % 3000 == 0)
            {
                DoEffect();
            }
        }

        private void DoEffect()
        {
            Log.Message($"TICK");

            foreach(var map in AffectedMaps)
            {
                foreach(var pawn in map.mapPawns.AllPawns)
                {
                    if(!pawn.Position.Roofed(pawn.Map) && pawn.RaceProps.Humanlike)
                    {
                        HealthUtility.AdjustSeverity(pawn, HediffDefOfLocal.TestHediff, HediffDefOfLocal.TestHediff.initialSeverity);
                    }
                }
            }
        }

        public override void End()
        {
            base.End();

            Log.Message($"END");
        }
    }
}
