﻿using MyMod.Buildings;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Verse;
using Verse.AI;

namespace MyMod.Jobs
{
    public class JobDriver_CarryItemToBuilding : JobDriver
    {
        public Bulding_MyTestBuilding bulding_MyTestBuilding => TargetA.Thing as Bulding_MyTestBuilding;

        public Thing Item => TargetB.Thing;

        public override bool TryMakePreToilReservations(bool errorOnFailed)
        {
            if(pawn.Reserve(TargetA, job))
            {
                return pawn.Reserve(TargetB, job);
            }

            return false;
        }

        protected override IEnumerable<Toil> MakeNewToils()
        {
            yield return Toils_Reserve.Reserve(TargetIndex.B);

            yield return Toils_Goto.Goto(TargetIndex.B, PathEndMode.ClosestTouch).FailOnDespawnedNullOrForbidden(TargetIndex.B);

            yield return Toils_Haul.StartCarryThing(TargetIndex.B);

            yield return Toils_Goto.Goto(TargetIndex.A, PathEndMode.ClosestTouch).FailOnDespawnedNullOrForbidden(TargetIndex.A);

            yield return Toils_General.Wait(1000).WithProgressBarToilDelay(TargetIndex.A).FailOnDespawnedNullOrForbidden(TargetIndex.A);

            Toil finish = new Toil();
            finish.initAction = delegate
            {
                if (bulding_MyTestBuilding != null)
                {
                    pawn.carryTracker.TryDropCarriedThing(bulding_MyTestBuilding.Position, ThingPlaceMode.Near, out Thing result);

                    bulding_MyTestBuilding.LoadItem(Item);
                    bulding_MyTestBuilding.Complete = false;
                }
            };
            finish.defaultCompleteMode = ToilCompleteMode.Instant;

            yield return finish;
        }
    }
}
