﻿using MyMod.Buildings;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Verse;
using Verse.AI;

namespace MyMod.Jobs
{
    public class JobDriver_GetItemFromBuilding : JobDriver
    {
        public Bulding_MyTestBuilding bulding_MyTestBuilding => TargetA.Thing as Bulding_MyTestBuilding;

        public override bool TryMakePreToilReservations(bool errorOnFailed)
        {
            return pawn.Reserve(TargetA, job);
        }

        protected override IEnumerable<Toil> MakeNewToils()
        {
            yield return Toils_Reserve.Reserve(TargetIndex.A);

            yield return Toils_Goto.Goto(TargetIndex.A, PathEndMode.ClosestTouch).FailOnDespawnedNullOrForbidden(TargetIndex.A);

            yield return Toils_General.Wait(1000).WithProgressBarToilDelay(TargetIndex.A).FailOnDespawnedNullOrForbidden(TargetIndex.A);

            Toil finish = new Toil();
            finish.initAction = delegate
            {
                if (bulding_MyTestBuilding != null)
                {
                    if(bulding_MyTestBuilding.ContainedThing != null)
                    {
                        bulding_MyTestBuilding.GetItem();
                    }
                }
            };
            finish.defaultCompleteMode = ToilCompleteMode.Instant;

            yield return finish;
        }
    }
}
