﻿using RimWorld.Planet;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Verse;

namespace MyMod.WorldObjects
{
    public class WorldObject_MySite : MapParent
    {
        public CaravanArrivalAction_EnterToMap CaravanArrivalAction_EnterToMap;

        public WorldObject_MySite()
        {
            CaravanArrivalAction_EnterToMap = new CaravanArrivalAction_EnterToMap(this);
        }

        public override IEnumerable<FloatMenuOption> GetFloatMenuOptions(Caravan caravan)
        {
            foreach(var action in CaravanArrivalActionUtility.GetFloatMenuOptions(() => CaravanArrivalAction_EnterToMap.CanVisit(caravan, this), () => CaravanArrivalAction_EnterToMap, "Do enter", caravan, Tile, this))
            {
                yield return action;
            }
        }

        public override bool ShouldRemoveMapNow(out bool alsoRemoveWorldObject)
        {
            alsoRemoveWorldObject = true;
            return !base.Map.mapPawns.AnyPawnBlockingMapRemoval;
        }

    }
}
